/*
 * A sample TSR that is connected with the TSR Library
 * functions. This program will display the current date
 * and time on the screen when the hot key is pressed.
 * The display remains and the TSR stays popped up until
 * another key is pressed.
 */

#include <dos.h>
#include <time.h>
#include "tsr.h"

#define VSG 0xb800    /* video memory segment (MDA=0xb000) */
#define ROW 10	      /* where the clock displays */
#define COL 30
#define vad(x,y) ((y)*160+(x)*2)

extern int terminating, suspending;
/* --- function called when TSR is popped up ----- */
void popup()
{
    int c, v;
    unsigned sv[24];
    char *tm;
    long tim;

    for (v = 0; v < 24; v++)    /* save the video memory */
        sv[v] = vpeek(VSG, vad(COL+v, ROW));
    while (!keyhit())    { /* run until a key is pressed    */
        time(&tim);    /* get the current date and time */
        tm = ctime(&tim);  /* display the date and time     */
        for (v = 0; v < 24; v++)
            vpoke(VSG, vad(COL+v, ROW), *(tm + v) | 0x7000);
    }

    terminating = ((c = get_char()) == 'u');
    suspending = (c == 's');

    /* -------- restore the video memory ---- */
    for (v = 0; v < 24; v++)
        vpoke(VSG, vad(COL+v, ROW), sv[v]);
}
/* --- null startup & shutdown functions --- */
void openfiles() {}
void closefiles() {}

